"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts = __importStar(require("typescript"));
function assertHeritageExtends(node) {
    if (node.heritageClauses) {
        if (node.heritageClauses.length !== 1 || node.heritageClauses[0].token !== ts.SyntaxKind.ExtendsKeyword) {
            throw new Error("There should only be 1 heritage clause and it should be 'extends'");
        }
    }
}
exports.assertHeritageExtends = assertHeritageExtends;
function assertKind(node, kind) {
    if (node.kind !== kind) {
        throw new Error("Expected node kind to be " + ts.SyntaxKind[kind] + ", but found " + ts.SyntaxKind[node.kind]);
    }
}
exports.assertKind = assertKind;
function assertExists(obj) {
    if (obj == null) {
        throw new Error('Expected an object to exist where it did not.');
    }
    return obj;
}
exports.assertExists = assertExists;
// DEPRECATED: Removing soon, I think
function isValidated(node) {
    assertHeritageExtends(node);
    if (node.heritageClauses) {
        var clause = node.heritageClauses[0];
        for (var _i = 0, _a = clause.types; _i < _a.length; _i++) {
            var clauseType = _a[_i];
            // assertKind(clauseType, ts.SyntaxKind.ExpressionWithTypeArguments);
            if (clauseType.expression.getText() === 'Validity') {
                return true;
            }
        }
    }
    return false;
}
