"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var ts = __importStar(require("typescript"));
var host = ts.createCompilerHost({});
if (!host || !host.readDirectory) {
    throw new Error();
}
var ParseConfigHost = /** @class */ (function () {
    function ParseConfigHost() {
        this.useCaseSensitiveFileNames = true;
    }
    ParseConfigHost.prototype.readDirectory = function (rootDir, extensions, excludes, includes, depth) {
        // TODO: Replace with not hot garbage
        if (host.readDirectory) {
            return host.readDirectory(rootDir, extensions, excludes, includes, depth);
        }
        else {
            throw new Error();
        }
    };
    ParseConfigHost.prototype.fileExists = function (path) {
        console.log(path);
        return true;
    };
    ParseConfigHost.prototype.readFile = function (path) {
        return fs.readFileSync(path).toString();
    };
    return ParseConfigHost;
}());
function getProgramFromConfig(path) {
    if (path === void 0) { path = 'tsconfig.json'; }
    var options = ts.readConfigFile('tsconfig.json', host.readFile);
    if (options.error) {
        throw options.error;
    }
    var config = ts.parseJsonConfigFileContent(options.config, new ParseConfigHost(), '.');
    return ts.createProgram(config.fileNames, config.options);
}
exports.getProgramFromConfig = getProgramFromConfig;
